#!/bin/sh
# Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
#
# This software is published by the license of CPU-OS License，you can use and
# distibuted this software under this License. See CPU-OS Liense for more detail.
#
# You should have receive a copy of CPU-OS License. If not, please contact us
# by email <support_os@cpu-os.ac.cn>

#check hosts configuration whether ok 
#return value: 1:hosts configuration ok 0:hosts configuration error

set -x

HOSTNAME=`hostname`

#check duplicate line in /etc/hosts
check_dup_line()
{
	if [ -f /etc/hosts ];then
		dup_line=`cat /etc/hosts | egrep -v '^(#|$)' | uniq -d`
		if [ "$dup_line" = "" ];then
			echo "have no dupline"	
			return 1
		else
			return 0
		fi
	else
		return 0
	fi
}

#Check /etc/hosts contains an entry for this server name
check_server_ip()
{
	if [ -f /etc/hosts ];then
		host_name_ip=`cat /etc/hosts | egrep -v '^(#|$|::1|localhost)' | grep ${HOSTNAME}`
		if [ "$host_name_ip" = "" ];then
			echo "No entry for the server name"	
			return 0
		else
			return 1
		fi	
	else
		return 0
	fi
}

#Check server hostname mapping
check_host_map()
{
	if [ -f /etc/hosts ];then
		map=`cat /etc/hosts | egrep -v '^(#|$)' | egrep '(localhost|::1)' | grep ${HOSTNAME}`
		if [ "$map" = "" ];then
			echo "this server hostname is not mapped to a local address" 
		fi
	fi
}


check_dup_line
check_host_map
check_server_ip
if [ $? = 1 ];then
	return 1
fi


set +x
