#!/bin/sh
# Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
#
# This software is published by the license of CPU-OS License，you can use and
# distibuted this software under this License. See CPU-OS Liense for more detail.
#
# You should have receive a copy of CPU-OS License. If not, please contact us
# by email <support_os@cpu-os.ac.cn>
#check whether wired  is ok
#return value: 1:wired link ok,and NIC ok; 2:wired no link,but NIC ok; 3:NIC error


if [ ! -d "/sys/class/net/" ]
then
	return 3
fi
if [ `ls /sys/class/net/ | wc -l` -eq 0 ]
then
	return 3
fi

rm -rf /tmp/wired-check.ok
rm -rf /tmp/wired-check.nolink
touch /tmp/wired-check.ok
touch /tmp/wired-check.nolink
for ethernet in `ls /sys/class/net/`
do
	if [ $ethernet = "lo" ]
	then
		continue
	fi
	linkinfo=`mii-tool $ethernet`
	echo $linkinfo | grep "ok" >> /tmp/wired-check.ok
	echo $linkinfo | grep "no link" >> /tmp/wired-check.nolink
done
if [ `cat /tmp/wired-check.ok | wc -l` -gt 0 ]; then
	return 1
elif [ `cat /tmp/wired-check.nolink | wc -l` -gt 0 ]; then
	return 2
else
	return 3
fi
